/*
 * commands.h
 *
 *  Created on: 12.05.2010
 *      Author: dilma
 */

#ifndef COMMANDS_H_
#define COMMANDS_H_

#define CMD_TYPE const gchar *

extern const gchar *CMD_NEW;
extern const gchar *CMD_OPEN;
extern const gchar *CMD_SAVE;
extern const gchar *CMD_SAVEAS;
extern const gchar *CMD_PRINT;
extern const gchar *CMD_REOPEN;
extern const gchar *CMD_EXIT;
extern const gchar *CMD_DELETE;
extern const gchar *CMD_FREEZ;
extern const gchar *CMD_CUT;
extern const gchar *CMD_COPY;
extern const gchar *CMD_COPY_LINK;
extern const gchar *CMD_PASTE;
extern const gchar *CMD_EDITOR;
extern const gchar *CMD_BRINGTOFRONT;
extern const gchar *CMD_SENDTOBACK;
extern const gchar *CMD_ERASE;
extern const gchar *CMD_FORMEDIT;
extern const gchar *CMD_INFO;
extern const gchar *CMD_PROPERTY;
extern const gchar *CMD_PROJECTS;
extern const gchar *CMD_ELEMENTS;
extern const gchar *CMD_NAVIGATE;
extern const gchar *CMD_RUN;
extern const gchar *CMD_DEBUG;
extern const gchar *CMD_TRACE;
extern const gchar *CMD_STOP;
extern const gchar *CMD_BUILD;
extern const gchar *CMD_TOOLS;
extern const gchar *CMD_CMDEDIT;
extern const gchar *CMD_STINFO;
extern const gchar *CMD_CAPTURE;
extern const gchar *CMD_COMPONENTS;
extern const gchar *CMD_HELP;
extern const gchar *CMD_FORUM;
extern const gchar *CMD_MAIL;
extern const gchar *CMD_DMASTER;
extern const gchar *CMD_ABOUT;
extern const gchar *CMD_SHA_INI;
extern const gchar *CMD_SHA_PAS;
extern const gchar *CMD_SHA_SOURCE;
extern const gchar *CMD_ECREATOR;
extern const gchar *CMD_WEB_BACK;
extern const gchar *CMD_WEB_FORWARD;
extern const gchar *CMD_WEB_REFRESH;
extern const gchar *CMD_ROOMS;
extern const gchar *CMD_UPLOAD;
extern const gchar *CMD_CLOSE;
extern const gchar *CMD_CLOSEALL;
extern const gchar *CMD_HICHAT;
extern const gchar *CMD_PN_DEBUG;
extern const gchar *CMD_PN_HELP;
extern const gchar *CMD_PN_INFO;
extern const gchar *CMD_UNDO;
extern const gchar *CMD_SEARCH;
extern const gchar *CMD_GROUP;
extern const gchar *CMD_UNGROUP;
extern const gchar *CMD_ALIGN;
extern const gchar *CMD_COMPILERS;
extern const gchar *CMD_PACK;
extern const gchar *CMD_TUTOR;
extern const gchar *CMD_MOVETO;
extern const gchar *CMD_ADDTEMP;
extern const gchar *CMD_USETEMP;
extern const gchar *CMD_MEDIA;
extern const gchar *CMD_ADDPPOINT;
extern const gchar *CMD_MAKEEXT;
extern const gchar *CMD_HUB_EX;
extern const gchar *CMD_BREAK;
extern const gchar *CMD_DODATA;
extern const gchar *CMD_LINECOLOR;
extern const gchar *CMD_BACK;
extern const gchar *CMD_FORWARD;
extern const gchar *CMD_PANELS;
extern const gchar *CMD_MN_FILE;
extern const gchar *CMD_MN_EDIT;
extern const gchar *CMD_MN_VIEW;
extern const gchar *CMD_MN_RUN;
extern const gchar *CMD_MN_SERVICE;
extern const gchar *CMD_MN_HELP;
extern const gchar *CMD_CONNECTPOINT;
extern const gchar *CMD_REDO;
extern const gchar *CMD_ELMOVEUP;
extern const gchar *CMD_ELMOVEDOWN;
extern const gchar *CMD_DELELEMENT;
extern const gchar *CMD_ADD_GROUP;
extern const gchar *CMD_ADD_TAB;
extern const gchar *CMD_DEL_TAB;
extern const gchar *CMD_EXAMPLES;
extern const gchar *CMD_MAKELEMENT;
extern const gchar *CMD_TRANSLATE;
extern const gchar *CMD_PUBLIC_SHA;
extern const gchar *CMD_UPDATE_SHA;
extern const gchar *CMD_LIST_SHA;
extern const gchar *CMD_CLONE;
extern const gchar *CMD_MAKE_WMDOCK;
extern const gchar *CMD_WM_SPLIT;
extern const gchar *CMD_SELECTALL;
extern const gchar *CMD_PAGEUP;
extern const gchar *CMD_PAGEDOWN;
extern const gchar *CMD_REPLACETO;
extern const gchar *CMD_SLIDEDOWN;
extern const gchar *CMD_SLIDERIGHT;
extern const gchar *CMD_SLIDEDIAG;
extern const gchar *CMD_SDK_EDITOR;
extern const gchar *CMD_PASTE_DEBUG;
extern const gchar *CMD_PASTE_DODATA;
extern const gchar *CMD_PASTE_STRCAT;
extern const gchar *CMD_PASTE_HUB;
extern const gchar *CMD_CLEAR_LINK;
extern const gchar *CMD_RENAME_POINT;
extern const gchar *CMD_INSERT_POINT;
extern const gchar *CMD_MOVE_POINT;
extern const gchar *CMD_MAKEHINT;
extern const gchar *CMD_SHOW_LH;
extern const gchar *CMD_REMOVE_LH;
extern const gchar *CMD_QPAN_ADD;
extern const gchar *CMD_QPAN_ADDBTN;
extern const gchar *CMD_QPAN_SHOW;
extern const gchar *CMD_QPAN_SHOWALL;
extern const gchar *CMD_QPAN_HIDEALL;
extern const gchar *CMD_BIND_RECT;
extern const gchar *CMD_BIND_CENTER;
extern const gchar *CMD_BIND_PADDING;
extern const gchar *CMD_DEL_POINT;
extern const gchar *CMD_ZOOMIN;
extern const gchar *CMD_ZOOMOUT;
extern const gchar *CMD_PN_ERRORS;
extern const gchar *CMD_PAL_FILTER;
extern const gchar *CMD_SVN;
extern const gchar *CMD_SVN_UPDATE;
extern const gchar *CMD_SVN_LOG;
extern const gchar *CMD_SVN_SHOW;
extern const gchar *CMD_DEBUG_A;
extern const gchar *CMD_FULLSCREEN;
extern const gchar *CMD_PN_REP;
extern const gchar *CMD_SAVETOREP;
extern const gchar *CMD_SEARCHNEXT;
extern const gchar *CMD_ICONS;
extern const gchar *CMD_DECOM_PAL;

#endif /* COMMANDS_H_ */
